package mt.mas.sampleapplication;

import java.util.LinkedList;
import java.util.List;
import javax.swing.JOptionPane;
import mt.mas.sampleapplication.gui.FrameNumberCounter;
import mt.mas.sampleapplication.gui.FrameNumberGenerator;

/**
 *
 * @author  Mariusza
 */
public class MainApp extends javax.swing.JFrame {
    private List<Integer> numbers = new LinkedList<Integer>();
    
    /** Creates new form MainApp */
    public MainApp() {
        initComponents();
    }

    private void count() {
        if(numbers == null || numbers.size() < 1) {
            JOptionPane.showInternalMessageDialog(desktopPane, "Nie wygenerowano listy liczb!");
            return;
        }        
        FrameNumberCounter frame = new FrameNumberCounter(numbers);
        frame.setVisible(true);
        this.desktopPane.add(frame);
    }

    private void exit() {
        System.exit(0);
    }

    private void generateNumbers() {
        FrameNumberGenerator frame = new FrameNumberGenerator(numbers);
        frame.setVisible(true);
        this.desktopPane.add(frame);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnlMain = new javax.swing.JPanel();
        desktopPane = new javax.swing.JDesktopPane();
        jToolBar1 = new javax.swing.JToolBar();
        btnGenerate = new javax.swing.JButton();
        btnCount = new javax.swing.JButton();
        lblStatus = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        openMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        saveAsMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        cutMenuItem = new javax.swing.JMenuItem();
        copyMenuItem = new javax.swing.JMenuItem();
        pasteMenuItem = new javax.swing.JMenuItem();
        deleteMenuItem = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        mnuDataGenerate = new javax.swing.JMenuItem();
        mnuDataCount = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        contentMenuItem = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        pnlMain.setLayout(new java.awt.BorderLayout());
        pnlMain.add(desktopPane, java.awt.BorderLayout.CENTER);

        jToolBar1.setRollover(true);

        btnGenerate.setText("Generate");
        btnGenerate.setFocusable(false);
        btnGenerate.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnGenerate.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnGenerate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGenerateActionPerformed(evt);
            }
        });
        jToolBar1.add(btnGenerate);

        btnCount.setText("Count");
        btnCount.setFocusable(false);
        btnCount.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnCount.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnCount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCountActionPerformed(evt);
            }
        });
        jToolBar1.add(btnCount);

        pnlMain.add(jToolBar1, java.awt.BorderLayout.NORTH);

        lblStatus.setText("#");
        pnlMain.add(lblStatus, java.awt.BorderLayout.PAGE_END);

        fileMenu.setText("File");

        openMenuItem.setText("Open");
        fileMenu.add(openMenuItem);

        saveMenuItem.setText("Save");
        fileMenu.add(saveMenuItem);

        saveAsMenuItem.setText("Save As ...");
        fileMenu.add(saveAsMenuItem);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        editMenu.setText("Edit");

        cutMenuItem.setText("Cut");
        editMenu.add(cutMenuItem);

        copyMenuItem.setText("Copy");
        editMenu.add(copyMenuItem);

        pasteMenuItem.setText("Paste");
        editMenu.add(pasteMenuItem);

        deleteMenuItem.setText("Delete");
        editMenu.add(deleteMenuItem);

        menuBar.add(editMenu);

        jMenu1.setLabel("Data");

        mnuDataGenerate.setText("Generate");
        mnuDataGenerate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuDataGenerateActionPerformed(evt);
            }
        });
        jMenu1.add(mnuDataGenerate);

        mnuDataCount.setText("Count");
        mnuDataCount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnuDataCountActionPerformed(evt);
            }
        });
        jMenu1.add(mnuDataCount);

        menuBar.add(jMenu1);

        helpMenu.setText("Help");

        contentMenuItem.setText("Contents");
        helpMenu.add(contentMenuItem);

        aboutMenuItem.setText("About");
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnlMain, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnlMain, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        exit();
    }//GEN-LAST:event_exitMenuItemActionPerformed

private void btnGenerateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGenerateActionPerformed
    generateNumbers();
}//GEN-LAST:event_btnGenerateActionPerformed

private void mnuDataGenerateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuDataGenerateActionPerformed
    generateNumbers();
}//GEN-LAST:event_mnuDataGenerateActionPerformed

private void mnuDataCountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnuDataCountActionPerformed
    count();
}//GEN-LAST:event_mnuDataCountActionPerformed

private void btnCountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCountActionPerformed
    count();
}//GEN-LAST:event_btnCountActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainApp().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JButton btnCount;
    private javax.swing.JButton btnGenerate;
    private javax.swing.JMenuItem contentMenuItem;
    private javax.swing.JMenuItem copyMenuItem;
    private javax.swing.JMenuItem cutMenuItem;
    private javax.swing.JMenuItem deleteMenuItem;
    private javax.swing.JDesktopPane desktopPane;
    private javax.swing.JMenu editMenu;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JLabel lblStatus;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem mnuDataCount;
    private javax.swing.JMenuItem mnuDataGenerate;
    private javax.swing.JMenuItem openMenuItem;
    private javax.swing.JMenuItem pasteMenuItem;
    private javax.swing.JPanel pnlMain;
    private javax.swing.JMenuItem saveAsMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    // End of variables declaration//GEN-END:variables

}
